package no.ntnu.idatt1002.demo.data.Budget;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class FileHandlingBudgetArchive {
  private static final String path = System.getProperty("user.dir") + "/src/main/resources/";
  private static final String archiveFileType = ".arc";

  public static void writeBudgetRegisterToArchive(BudgetRegister budgetNames) throws IOException {
    try (BufferedWriter bw = new BufferedWriter(new FileWriter(System.getProperty("user.dir") + "/" + path + "Archive.txt"))) {
      System.out.println(System.getProperty("user.dir") + "/" + path + "Archive.txt");
      bw.write(budgetNames.toString());
    } catch (IOException ioe) {
      ioe.printStackTrace();
      throw new IOException("Could not write to file: Archive.txt");
    }
  }

  public static boolean isBudgetRegisterEmpty() throws IOException {
    try (BufferedReader br = new BufferedReader(new FileReader(System.getProperty("user.dir") + "/src/main/resources/"
        + "Archive.txt"))) {
      return br.readLine() == null;
    }
  }
  public static BudgetRegister readBudgetArchive(String fileTitle) throws IOException {
    BufferedReader br;
    BudgetRegister budgetRegister = null;
    String budgetName;

    try {
      br = new BufferedReader(
          new FileReader(System.getProperty("user.dir") + "/" + path
              + "Archive.txt"));
    } catch (IOException ioe) {
      throw new IOException("File does not exist", ioe);
    }

    String line;
    String nextLine = br.readLine();
    while ((line = nextLine) != null) {
      System.out.println(line);
      nextLine = br.readLine();
      budgetName = line;

      if(budgetRegister == null){
        budgetRegister = new BudgetRegister();
      }
      budgetRegister.addBudgetName(budgetName);
    }
    return budgetRegister;
  }

  public static void writeSavingsToFile() {

  }

  public static boolean deleteBudgetDirectory(String budgetID) {
    File targetDirectory = new File(System.getProperty("user.dir") + "/src/main/resources/" + budgetID);
    System.out.println("Deleting directory:" + targetDirectory.getPath());

    String[]entries = targetDirectory.list();
    assert entries != null;
    for(String file : entries){
      File currentFile = new File(targetDirectory.getPath(),file);
      System.out.println("Deleting file:" + currentFile.delete());
    }

    return targetDirectory.delete();
  }
}
